require "thor"

module FastTrack
  class Commands < Thor
    desc "new APP_NAME", "Create a new Rails app, called APP_NAME"

    method_option :tracks, {
      :type     => :array,
      :aliases  => "-T",
      :desc     => "Tracks to run with this app",
      :required => true
    }

    def new_app(name)
      FastTrack::App.new(name, options[:tracks])
    end

    desc "list", "List all available tracks, with descriptions"

    def list
      puts ""
      puts "Available Tracks:"
      puts ""
      FastTrack::Track.descendants.each do |track|
        unless track.name.blank?
          puts "#{track.name.ljust(30)} -- #{track.description}"
        end
      end
      puts ""
    end
  end
end
