require "hooks"

module FastTrack
  class Track
    include Hooks
    include TrackMethods

    attr_accessor :generator

    def initialize(generator)
      @generator = generator
    end

    class << self
      def args=(other)
        @args = other
      end

      def args
        @args || []
      end

      def name_from_args
        if args.length == 1
          @args.first
        end
      end

      def name(name = nil)
        if name.blank?
          # @name || name_from_args || ""
          name_from_args || ""
        else
          @name = name
        end
      end

      def description(arg = nil)
        if arg.blank?
          @description
        else
          @description = arg
        end
      end

      alias :desc :description

      # The required tracks this track needs.
      def requires(*args)
        if args.blank?
          @requires
        else
          @requires = args
        end
      end

      def rubygem(name)
        @rubygem = name
      end

      def tutorial_url(url)
        @tutorial_urls ||= []
        @tutorial_urls << url
      end

      def github_url(url)
        @github_url = url
      end

      def github_description(description)
        @github_description = description
      end

      # Describe a Gemfile using `gem` and `gem_group`
      def gemfile(&block)
        @gemfile_block = block
      end

      def gemfile_block
        @gemfile_block
      end

      # Tasks before migration
      def before_migrate(&block)
        @before_migrate_block = block
      end

      def before_migrate_block
        @before_migrate_block
      end

      alias :before_migration :before_migrate

      # Tasks before migration
      def after_migrate(&block)
        @after_migrate_block = block
      end

      def after_migrate_block
        @after_migrate_block
      end

      alias :after_migration :after_migrate

      # After bundle
      def after_bundle(&block)
        @after_bundle_block = block
      end

      def after_bundle_block
        @after_bundle_block
      end
    end
  end
end
