track "devise" do
  name "Vanilla Devise"
  desc "Plain devise with no config options"

  gemfile do
    gem 'devise'
  end

  before_migrate do
    generate "devise:install"
  end
end

track "devise_user_class" do
  name "Devise User class"
  desc "Install devise, and add a devise class called 'User'"

  before_migrate do
    generate "devise", "User"
  end
end

track "devise_views" do
  name "Devise views"
  desc "Install devise views"

  before_migrate do
    generate "devise:views"
  end
end

track "user_profile" do
  name "User Profile"
  desc "Given a user class, adds a profile class to store personal information about the user."

  before_migrate do
    model "Profile", {
      "first_name"              => "string",
      "last_name"               => "string",
      "favorite_color"          => "string",
      "user_id"                 => "integer"
    }
  end
end

track "devise_plus_admin" do
  gemfile do
    gem 'devise'
  end

  before_migrate do
    generate "devise:install"
    generate "devise", config.user_class
  end
end

track "devise_three_tier" do
  gemfile do
    gem 'devise'
  end

  before_migrate do
    generate "devise:install"
    generate "devise", config.user_class
  end
end
