# Based on this gist: https://gist.github.com/schleg/993566
track "omniauth" do
  desc "Use Omniauth"

  gemfile do
    gem "omniauth"
  end
end

track "omniauth_authentications" do
  desc "Omniauth + User Authorization table"

  before_migrate do
    migration "add_name_to_users", {
      "name" => "string"
    }

    model "Authorization", {
      "provider" => "string",
      "uid"      => "string",
      "user_id"  => "integer",
      "token"    => "string",
      "secret"   => "string",
      "name"     => "string",
      "link"     => "string"
    }
  end
end

track "omniauth_facebook" do
  gemfile do
    gem "omniauth"
    gem "omniauth-facebook"
  end

  before_migration do
    migration "AddUidToUsers", {
      "provider" => "string",
      "uid"      => "string",
      "name"     => "string"
    }
  end

  after_migration do
    gsub_file "config/routes.rb", "devise_for :users", 'devise_for :users, :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }'

    file "app/controllers/users/omniauth_callbacks_controller.rb", controller_file
    file "config/initializers/devise_facebook.rb",                 initializer_file
    # TODO:
    file "app/models/user.rb",                                     user_file, :force => true

    # TODO: Use options passed to thor
    file "config/facebook.yml",                                    facebook_yml
  end

  def template_directory
    "devise_facebook"
  end

  def controller_file
    read_file("omniauth_controller.rb")
  end

  def initializer_file
    read_file("initializer.rb")
  end

  def facebook_yml
    read_file("facebook.yml")
  end

  def user_file
    read_file("user.rb")
  end
end
