track "thin" do
  name "Thin"
  desc "Uses the thin rack web server"

  gemfile do
    gem "thin"
  end
end

track "production_thin" do
  requires "thin"

  name  "Production Thin"
  desc  "Install thin on a production server"

  tutorial_url "http://kvz.io/blog/2010/09/21/ruby-with-nginx-on-ubuntu-lucid/"
  tutorial_url "http://jordanhollinger.com/2011/04/22/how-to-use-thin-effectivly"

  after_bundle do
    run "rvmsudo thin install"
    create_file "/etc/thin/#{config.app_name}.yml", sample_thin_config
  end

  def template_directory
    "twitter_bootstrap"
  end

  def flash_helper
    read_file("bootstrap_flash_helper.rb")
  end
end

track "nginx_thin" do
  requires "thin"

  tutorial_url "http://www.funonrails.com/2010/03/nginx-and-thin-installation-and.html"

  # TODO!
end
