track "twitter_bootstrap" do
  gemfile do
    gem "twitter-bootstrap-rails"
    gem "less-rails"
    gem 'jquery-rails'

    gem_group :assets do
      gem 'less'
      gem 'commonjs'
      gem 'therubyracer', :platforms => :ruby
    end
  end

  def template_directory
    "twitter_bootstrap"
  end

  def flash_helper
    read_file("bootstrap_flash_helper.rb")
  end

  def application_css
    read_file("application.css")
  end

  before_migrate do
    generate "controller Home index"
    route "root to: 'home#index'"

    generate "bootstrap:install less"
    generate "bootstrap:layout application fixed --force"

    create_file "app/helpers/bootstrap_flash_helper.rb",  flash_helper
    create_file "app/assets/stylesheets/application.css", application_css, force: true
  end
end

track "twitter_boostrap_nav_bar" do
  requires "devise"

  def template_directory
    "twitter_bootstrap_nav_bar"
  end

  def layout_for_application
    read_file("application.html.erb")
  end

  def nav_bar
    read_file("_navigation.html.erb")
  end

  def messages
    read_file("_messages.html.erb")
  end

  def application_helper
    read_file("application_helper.rb")
  end

  before_migrate do
    create_file "app/views/layouts/application.html.erb", layout_for_application, force: true
    create_file "app/helpers/application_helper.rb",      application_helper,     force: true

    # NOTE: _navigation.html.erb requires Devise to work properly!
    create_file "app/views/layouts/_navigation.html.erb", nav_bar
    create_file "app/views/layouts/_messages.html.erb",   messages
  end
end
